<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <el-form-item label="用户姓名" prop="userId">
        <user-selector
          manage
          v-model="queryParams.userId"
          clearable
          @change="handleQuery"
          :prepend="{ id: 0, nickname: $t('未选择用户') }"
        />
      </el-form-item>
      <el-form-item label="权限范围" prop="titleZh">
        <el-select
          v-model="queryParams.permissionFw"
          clearable
          style="width: 200px"
        >
          <el-option label="本人" value="1"></el-option>
          <el-option label="部门" value="2"></el-option>
          <el-option label="全公司" value="3"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">
          {{ $t("搜索") }}</el-button
        >
        <el-button icon="el-icon-refresh" @click="resetQuery">
          {{ $t("重置") }}
        </el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['report:permission:create']"
        >
          {{ $t("新增") }}</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          v-show="false"
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['my:test:export']"
        >
          {{ $t("导出") }}</el-button
        >
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>
    <el-table v-loading="loading" :data="list">
      <el-table-column label="编号" align="center" prop="id" />
      <el-table-column label="用户ID" align="center" prop="userId" />
      <el-table-column label="用户姓名" align="center" prop="userName" />
      <el-table-column label="权限类型" align="center" prop="permissionFw">
        <template slot-scope="scope">
          <span v-if="scope.row.permissionFw == 1">本人</span>
          <span v-else-if="scope.row.permissionFw == 2">部门</span>
          <span v-else-if="scope.row.permissionFw == 3">全公司</span>
          <span v-else>权限定义异常</span>
        </template>
      </el-table-column>
      <el-table-column
        label="部门信息"
        align="center"
        prop="deptName"
        width="100"
      >
      </el-table-column>
      <el-table-column label="修改日期" align="center" prop="updateTime">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.updateTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['report:permission:update']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['report:permission:delete']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNo"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="用户姓名" prop="userId">
          <user-selector
            v-model="form.userId"
            clearable
            @change="handleQuery"
            :prepend="{ id: 0, nickname: $t('未选择用户') }"
          />
        </el-form-item>
        <el-form-item label="权限范围" prop="permissionFw">
          <el-select v-model="form.permissionFw" clearable style="width: 200px">
            <el-option label="本人" value="1"></el-option>
            <el-option label="部门" value="2"></el-option>
            <el-option label="全公司" value="3"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="部门信息" prop="deptId">
          <treeselect
            v-model="form.deptId"
            :options="deptOptions"
            :show-count="true"
            :placeholder="$t('请选择部门')"
            :normalizer="normalizer"
          />
        </el-form-item>
        <el-form-item label="数据导出权" prop="exportdataq">
          <el-radio-group v-model="form.exportdataq">
            <el-radio label="1">有</el-radio>
            <el-radio label="0">无</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import UserSelector from "@/components/UserSelector";
import Treeselect from "@riophae/vue-treeselect";
//自定义目录数样式
import "@/assets/styles/vue-treeselect.css";
//部门树需要的函数
import { listSimpleDepts } from "@/api/system/dept";
import {
  create,
  update,
  del,
  getModel,
  getPageList,
  exportExcel,
} from "@/api/report/EcwReportPermission";

//2024-05-01合并
export default {
  name: "EcwReportPermission",
  components: {
    UserSelector,
    Treeselect,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 测试列表
      list: [],
      // 弹出层标题
      title: "",
      //是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        userId: null, //用户ID
        userName: null, //用户姓名
        permissionFw: null, //权限范围
        deptId: null, //部门信息
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      deptOptions: undefined,
    };
  },
  created() {
    this.getTreeselect();
    this.getList();
  },

  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = { ...this.queryParams };
      // 执行查询
      getPageList(params).then((response) => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        userId: undefined, //用户ID
        userName: undefined, //用户姓名
        permissionFw: undefined, //权限范围
        deptId: null, //部门
        exportdataq: "0", //是否有数据导出权
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加测试";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getModel(id).then((response) => {
        this.form = response.data;
        //要把数据类型做一下转换，不让是在页面上显示不了lable信息
        this.form.permissionFw = response.data.permissionFw.toString();

        //vue 控件对类型很敏感，类型不对很容易出问题
        this.form.userId = parseInt(response.data.userId);
        if (
          response.data.deptId == null ||
          response.data.deptId == undefined ||
          response.data.deptId == ""
        ) {
          //treeselect 若是空值,必须是null，不能赋值""，0，等。
          this.form.deptId = null;
        }
        //vue控件的数据类型一定要和后台一致
        this.form.exportdataq = response.data.exportdataq.toString();
        this.open = true;
        this.title = "修改测试";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (!valid) {
          return;
        }
        if (
          this.form.userId == null ||
          this.form.userId == undefined ||
          this.form.userId == ""
        ) {
          this.$message.error("请选择用户");
          return;
        }

        if (
          this.form.permissionFw == null ||
          this.form.permissionFw == undefined ||
          this.form.permissionFw == ""
        ) {
          this.$message.error("请选择权限范围");
          return;
        } else {
          if (this.form.permissionFw == 1 || this.form.permissionFw == 3) {
            //本人和全公司权限，不用选择部门
            this.form.deptId = "";
          } else if (this.form.permissionFw == 2) {
            //部门权限，需要选中部门信息
            if (
              this.form.deptId == null ||
              this.form.deptId == undefined ||
              this.form.deptId == ""
            ) {
              this.$message.error("请选择部门");
              return;
            }
          }
        }

        // 修改的提交
        if (this.form.id != null) {
          update(this.form).then((response) => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        create(this.form).then((response) => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal
        .confirm('是否确认删除测试编号为"' + id + '"的数据项?')
        .then(function () {
          return del(id);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = { ...this.queryParams };
      params.pageNo = undefined;
      params.pageSize = undefined;
      // 执行导出
      this.$modal
        .confirm("是否确认导出所有测试数据项?")
        .then(() => {
          this.exportLoading = true;
          return exportExcel(params);
        })
        .then((response) => {
          this.$download.excel(response, "${table.classComment}.xls");
          this.exportLoading = false;
        })
        .catch(() => {});
    },
    Test() {
      this.form.userId = 31;
    },
    /** 查询部门下拉树结构 + 岗位下拉 */
    getTreeselect() {
      listSimpleDepts().then((response) => {
        // 处理deptOptions 参数
        this.deptOptions = [];
        this.deptOptions.push(...this.handleTree(response.data, "id"));
      });
    },
    //格式化部门的下拉框
    normalizer(node) {
      return {
        id: node.id,
        label: node.name,
        children: node.children,
      };
    },
  },
};
</script>
